Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/CreateThemeAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/CreateThemeAction.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/CreateThemeAction.java	(working copy)
@@ -84,21 +84,22 @@
         String language = (String) jsParameters.get("language");
         Site site = _siteManager.getSite(siteName);
         
-        String label = StringUtils.defaultString((String) jsParameters.get("label"));
-        
-        // Check that the theme doesn't already exist.
-        if (themeExists(label, siteName, language))
-        {
-            result.put("error", "theme-already-exists");
-            return result;
-        }
+        String originalLabel = StringUtils.defaultString((String) jsParameters.get("label"));
         
         ModifiableTraversableAmetysObject rootNode = DirectoryHelper.getThemesNode(site, language);
         
-        DefaultTheme theme = rootNode.createChild(DefaultThemeFactory.THEME_NODE_NAME, DefaultThemeFactory.THEME_NODE_TYPE);
+        // Handle identical labels
+        String label = originalLabel;
+        int index = 2;
+        while (rootNode.hasChild(DirectoryHelper.normalizeString(label)))
+        {
+            label = originalLabel + "-" + (index++);
+        }
         
-        theme.setLabel(label);
+        DefaultTheme theme = rootNode.createChild(DirectoryHelper.normalizeString(label), DefaultThemeFactory.THEME_NODE_TYPE);
         
+        theme.setLabel(originalLabel);
+
         rootNode.saveChanges();
         
         result.put("id", theme.getId());
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/DeleteThemeAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/DeleteThemeAction.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/DeleteThemeAction.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2012 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -25,7 +25,6 @@
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.environment.SourceResolver;
-import org.apache.commons.lang.ArrayUtils;
 import org.apache.commons.lang.StringUtils;
 
 import org.ametys.cms.observation.AbstractNotifierAction;
@@ -33,13 +32,11 @@
 import org.ametys.plugins.linkdirectory.DirectoryEvents;
 import org.ametys.plugins.linkdirectory.DirectoryHelper;
 import org.ametys.plugins.linkdirectory.Theme;
-import org.ametys.plugins.linkdirectory.link.ThemeExpression;
 import org.ametys.plugins.linkdirectory.repository.DefaultLink;
 import org.ametys.plugins.linkdirectory.repository.DefaultTheme;
 import org.ametys.plugins.repository.AmetysObjectIterable;
 import org.ametys.plugins.repository.ModifiableAmetysObject;
 import org.ametys.plugins.repository.UnknownAmetysObjectException;
-import org.ametys.web.repository.page.ModifiableZoneItem;
 
 /**
  * Action which deletes a directory {@link Theme}.
@@ -71,7 +68,6 @@
                 
                 // Remove references
                 List<String> modifiedLinks = _deleteThemeRefIntoLinks(siteName, language, id);
-                _deleteThemeRefIntoServices(siteName, language, id);
                 
                 _observationManager.notify(new Event(_getCurrentUser(), DirectoryEvents.THEME_DELETED, id, new String[] {siteName, language}));
                 
@@ -94,7 +90,7 @@
     {
         List<String> modifiedLinks = new ArrayList<String>();
         
-        String xPathQuery = DirectoryHelper.getLinkQuery(siteName, lang, new ThemeExpression(themeId));
+        String xPathQuery = DirectoryHelper.getLinksQuery(siteName, lang, new ThemeExpression(themeId));
         
         AmetysObjectIterable<DefaultLink> links = _resolver.query(xPathQuery);
         
@@ -107,23 +103,4 @@
         
         return modifiedLinks;
     }
-    
-    private void _deleteThemeRefIntoServices (String siteName, String lang, String themeId)
-    {
-        String xPathQuery = "//element(" + siteName + ", ametys:site)/ametys-internal:sitemaps/" + lang + "//element(*, ametys:zoneItem)[@ametys-internal:service = 'org.ametys.plugins.linkdirectory.DirectoryService']"; 
-        AmetysObjectIterable<ModifiableZoneItem> zoneItems = _resolver.query(xPathQuery);
-        for (ModifiableZoneItem zoneItem : zoneItems)
-        {
-            String themes = zoneItem.getServiceParameters().getString("themes", null);
-            String[] themeArr = themes != null ? StringUtils.split(themes, ',') : new String[0];
-            
-            if (ArrayUtils.indexOf(themeArr, themeId) != -1)
-            {
-                String[] updatedThemes = (String[]) ArrayUtils.removeElement(themeArr, themeId);
-                zoneItem.getServiceParameters().setMetadata("themes", StringUtils.join(updatedThemes, ","));
-                zoneItem.saveChanges();
-            }
-        }
-    }
-
 }
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeExpression.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeExpression.java	(working copy)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeExpression.java	(working copy)
@@ -13,7 +13,7 @@
  *  See the License for the specific language governing permissions and
  *  limitations under the License.
  */
-package org.ametys.plugins.linkdirectory.link;
+package org.ametys.plugins.linkdirectory.theme;
 
 import org.ametys.plugins.linkdirectory.repository.DefaultLink;
 import org.ametys.plugins.repository.query.expression.Expression;
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeGenerator.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeGenerator.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/ThemeGenerator.java	(working copy)
@@ -28,6 +28,7 @@
 import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
+import org.ametys.plugins.linkdirectory.DirectoryHelper;
 import org.ametys.plugins.linkdirectory.repository.DefaultTheme;
 import org.ametys.plugins.repository.AmetysObjectResolver;
 
@@ -70,8 +71,8 @@
     {
         AttributesImpl attrs = new AttributesImpl();
         attrs.addCDATAAttribute("id", theme.getId());
-        
         attrs.addCDATAAttribute("label", StringUtils.defaultString(theme.getLabel()));
+        attrs.addCDATAAttribute("name", theme.getName());
         
         XMLUtils.createElement(contentHandler, "theme", attrs);
     }
Index: main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/UpdateThemeAction.java
===================================================================
--- main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/UpdateThemeAction.java	(revision 28682)
+++ main/plugin-link-directory/src/org/ametys/plugins/linkdirectory/theme/UpdateThemeAction.java	(working copy)
@@ -15,8 +15,10 @@
  */
 package org.ametys.plugins.linkdirectory.theme;
 
+import java.util.ArrayList;
 import java.util.Collections;
 import java.util.HashMap;
+import java.util.List;
 import java.util.Map;
 
 import org.apache.avalon.framework.parameters.Parameters;
@@ -27,8 +29,11 @@
 
 import org.ametys.cms.observation.Event;
 import org.ametys.plugins.linkdirectory.DirectoryEvents;
+import org.ametys.plugins.linkdirectory.DirectoryHelper;
 import org.ametys.plugins.linkdirectory.Theme;
+import org.ametys.plugins.linkdirectory.repository.DefaultLink;
 import org.ametys.plugins.linkdirectory.repository.DefaultTheme;
+import org.ametys.plugins.repository.AmetysObjectIterable;
 import org.ametys.plugins.repository.UnknownAmetysObjectException;
 
 /**
@@ -62,17 +67,39 @@
             
             theme.saveChanges();
             
+            List<String> modifiedLinks = _getReferencingLinks(siteName, language, id);
+            
             result.put("id", theme.getId());
             
             _observationManager.notify(new Event(_getCurrentUser(), DirectoryEvents.THEME_MODIFIED, theme));
+            
+            if (modifiedLinks.size() > 0)
+            {
+                result.put("modified-links", StringUtils.join(modifiedLinks, ","));
+            }
         }
         catch (UnknownAmetysObjectException e)
         {
             result.put("error", "unknown-theme");
-            getLogger().error("Unable to edit theme of id '" + id + ", because it does not not exist.", e);
+            getLogger().error("Unable to edit theme of id '" + id + ", because it does not exist.", e);
         }
         
         return result;
     }
 
+    private List<String> _getReferencingLinks (String siteName, String lang, String themeId)
+    {
+        List<String> modifiedLinks = new ArrayList<String>();
+        
+        String xPathQuery = DirectoryHelper.getLinksQuery(siteName, lang, new ThemeExpression(themeId));
+        
+        AmetysObjectIterable<DefaultLink> links = _resolver.query(xPathQuery);
+        
+        for (DefaultLink link : links)
+        {
+            modifiedLinks.add(link.getId());
+        }
+        
+        return modifiedLinks;
+    }
 }
